#!/usr/bin/python
#######################################################################################
# Keep the best aligned read for multiple aligned reads and remove others.
#######################################################################################
import string
import sys
import operator

genome = ""
read_len = 0
n_snp = 0
n_match = 0
left_match = 0
right_match = 0
abnormal_isize_0 = 0
abnormal_isize_1 = 0	
bound_len_thresh = 0

SOFT_CLIPPING = 3
UNMAPPED = 5
class split_read:
	def __init__(self):
		self.line=""
		self.read_start=""
		self.gap_start=0
		self.gap_size=0
		self.left_len=0
		self.right_len=0
		self.type=0
		self.chr=""
		self.seq=""
		self.mpos=0
		self.strand=0
		self.gap_end =0
		self.isize=0
		self.mismatch=0
		self.score=0
		self.difficulty=0
		self.chrA=""
		self.chrB=""
		self.posA=""
		self.posB=""
		self.strandA=""
		self.strandB=""
def usage():
	print "%s [ctx alignment file]" % sys.argv[0]
def load_genome (contig_file):	
	global genome
	fd = open(contig_file, "r")
	lines=fd.readlines()
	#assert(lines[0][0]=='>')
	genome = "".join(lines[1:]).replace('\n','').upper()
	fd.close()
def get_custom_field(line,field):
        pos1=line.find(field)
        if pos1>0:
                pos2=line[pos1:].find('\t')
                if pos2>0:
                        cs=line[pos1+5:pos1+pos2]
                else:
                        cs=line[pos1+5:]
                return cs
        else:
                return "-999"
                print "No custom field in sam file."
                print line
                sys.exit(1)

def build_contig (read_list):
	global genome
	global n_match
	global left_match
	global right_match
	global n_snp
	read_list.sort(key=operator.attrgetter("read_start"))
	n_a=0
	n_c=0
	n_g=0
	n_t=0
	n=0
	c=""
	k=0
	max=0
	n_snp=0
	n_match=0
	left_match=0
	right_match=0
	call_match_thresh = 9999
	if len(read_list) == 2:
		call_match_thresh = 1
	else:
		call_match_thresh = 2
	start = read_list[0].read_start
	end = read_list[0].gap_start 
	for i in range (start,end):
		for j in range (0,len(read_list)):
			if read_list[j].read_start <= i :
				k = i - read_list[j].read_start 
				c =  read_list[j].seq[k]
				n = n+1
				if  c == "A" or c == "a":
					n_a=n_a+1
				if  c == "C" or c == "c":
					n_c=n_c+1
				if  c == "G" or c == "g":
					n_g=n_g+1
				if  c == "T" or c == "t":
					n_t=n_t+1
			else:
				break
		if max < n_a:
			max = n_a
			c="A"
		if max < n_c:
                	max = n_c
	                c="C"
		if max < n_g:
                	max = n_g
	                c="G"
		if max < n_t:
                	max = n_t
	                c="T"
		if max > call_match_thresh and float(max)/float(n)>0.5:
			if genome[i-1]==c:
				n_match=n_match+1
				left_match = left_match + 1
			else:
				n_snp=n_snp+1
	
			
		n_a=0
	        n_c=0
		n_g=0
		n_t=0
        	n=0
		max=0
	if read_list[0].type == "INS":
		start =  read_list[0].gap_start 
		end = start +  read_list[-1].right_len
		for i in range (start,end):
			for j in range (0,len(read_list)):
				if read_list[j].right_len >= i-start+1 :
					k =  read_list[j].left_len + read_list[j].gap_size + (i-start+1) - 1
					c =  read_list[j].seq[k]
					n = n+1
					if  c == "A" or c == "a":
						n_a=n_a+1
					if  c == "C" or c == "c":
						n_c=n_c+1
					if  c == "G" or c == "g":
						n_g=n_g+1
					if  c == "T" or c == "t":
						n_t=n_t+1
			if max < n_a:
				max = n_a
				c="A"
			if max < n_c:
				max = n_c
				c="C"
			if max < n_g:
				max = n_g
				c="G"
			if max < n_t:
				max = n_t
				c="T"
			if max > call_match_thresh and float(max)/float(n)>0.5:
				if genome[i-1]==c:
					n_match=n_match+1
					right_match = right_match + 1
				else:
					n_snp=n_snp+1
			n_a=0
			n_c=0
			n_g=0
			n_t=0
			n=0
			max=0
		
	else:
		start =  read_list[0].gap_start +  read_list[0].gap_size
		end = start +  read_list[-1].right_len
		for i in range (start,end):
			for j in range (0,len(read_list)):
				if read_list[j].right_len >= i-start+1 :
					k =  read_list[j].left_len + (i-start+1) - 1
					c =  read_list[j].seq[k]
					n = n+1
					if  c == "A" or c == "a":
						n_a=n_a+1
					if  c == "C" or c == "c":
						n_c=n_c+1
					if  c == "G" or c == "g":
						n_g=n_g+1
					if  c == "T" or c == "t":
						n_t=n_t+1
			if max < n_a:
				max = n_a
				c="A"
			if max < n_c:
				max = n_c
				c="C"
			if max < n_g:
				max = n_g
				c="G"
			if max < n_t:
				max = n_t
				c="T"
			if max > call_match_thresh and float(max)/float(n)>0.5:
				if genome[i-1]==c:
					n_match=n_match+1
					right_match = right_match + 1
				else:
					n_snp=n_snp+1
			n_a=0
			n_c=0
			n_g=0
			n_t=0
			n=0
			max=0
	
	
def call_ctx(filename):
	global abnormal_isize_0
	global abnormal_isize_1
	global bound_len_thresh
	global n_match
        global left_match
        global right_match

	avg_iszie=0.0
	tol_isize=0
	mismatch_1=100
	mismatch_2=100
	mismatch_3=100
	score1=0
	score2=0
	score3=0
	soft_clipped = 0
	unmapped = 0
	f1=open(filename,'r')
	fout=open(filename+"_sv","w")
    	
	read_list=[]
	last_read=split_read()
	read_list.append(last_read)
	str = "@chrA\tchrA_gap_start\tchrA_strand\tchrB\tchrB_gap_end\tchrB_strand\ttype\tsupport_read_num\tcontig_match\tcontig_snp\tab_isize_0\tab_isize_1\tavg_isize\tmismatch_1\tmismatch_2\tmismatch_3\tleft_match\tright_match\tscore1\tscore2\tscore3\tmate_soft_clipped\tmate_unmapped\n"

	fout.write(str)
	
	while True:
		line = f1.readline()
		if line[0:1]=='@':
			continue
    		if len(line) == 0: # Zero length indicates EOF
        		break
		tmp=line.split()
		a=split_read()
		a.line=line
		a.chrA= tmp[2]
		a.chrB= get_custom_field(a.line,"TC:")
		a.posA= string.atoi(get_custom_field(a.line,"TS:i:"))
		a.posB= string.atoi(get_custom_field(a.line,"TE:i:"))
		a.score = string.atoi(get_custom_field(a.line,"AS:i:"))
		a.mismatch = string.atoi(get_custom_field(a.line,"MM:i:"))
		a.type= string.atoi(get_custom_field(a.line,"ST:i:"))
		if a.type == 2:
			a.strandA = "+"
			a.strandB = "+"
		elif a.type == 4:
			a.strandA = "-"
			a.strandB = "-"
		elif a.type == 31 or a.type == 32:
			a.strandA = "+"
			a.strandB = "-"
		elif a.type == 33 or a.type == 34:
			a.strandA = "-"
			a.strandB = "+"
		else:
			print a.type
		
		a.read_start = string.atoi(tmp[3])
		if a.chrA == read_list[0].chrA and a.chrB == read_list[0].chrB and a.posA == read_list[0].posA and a.posB == read_list[0].posB:
			is_dup_line=False
			for i in range (0,len(read_list)):
				if a.read_start == read_list[0].read_start:
					is_dup_line=True
					break
			#if is_dup_line:
			#	continue
			#tol_isize = tol_isize + a.isize
			read_list.append(a)
			
			
		else :
			if len(read_list)>=2:
				for i in range(0,len(read_list)):
					b = read_list[i]

					if b.mismatch < mismatch_1:
						mismatch_3 = mismatch_2
						mismatch_2 = mismatch_1
						mismatch_1 = b.mismatch
					elif b.mismatch < mismatch_2:
						mismatch_3 = mismatch_2
						mismatch_2 = b.mismatch
					elif b.mismatch < mismatch_3:
						mismatch_3 = b.mismatch
					
					if b.score > score1:
						score3 = score2
						score2 = score1
                                                score1 = b.score
                                        elif b.score > score2:
						score3 = score2
                                                score2 = b.score
                                        elif b.score > score3:
                                                score3 = b.score

				str = "%s\t%i\t%s\t%s\t%i\t%s\t%s\t%i\t%i\t%i\t%i\t%i\t%i\t%i\n" % (read_list[0].chrA,read_list[0].posA,read_list[0].strandA,read_list[0].chrB,read_list[0].posB,read_list[0].strandB,"CTX",len(read_list),mismatch_1,mismatch_2,mismatch_3,score1,score2,score3)
				#print str
				fout.write(str)
			read_list=[]
			abnormal_isize_0 = 0
			abnormal_isize_1 = 0
			mismatch_1=100
			mismatch_2=100
			mismatch_3=100
		 	score1=0
		        score2=0
		        score3=0
			soft_clipped = 0;
			unmapped = 0;
			avg_isize = 0
			if (a.left_len < bound_len_thresh or a.right_len < bound_len_thresh):
				read_list.append(split_read())
				#tol_isize = 0
			else:
				read_list.append(a)
				#tol_isize = a.isize
	if len(read_list)>=2:
		for i in range(0,len(read_list)):
			b = read_list[i]
			if b.mismatch < mismatch_1:
				mismatch_3 = mismatch_2
                                mismatch_2 = mismatch_1
				mismatch_1 = b.mismatch
			elif b.mismatch < mismatch_2:
				mismatch_3 = mismatch_2
				mismatch_2 = b.mismatch
			elif b.mismatch < mismatch_3:
				mismatch_3 = b.mismatch
			if b.score > score1:
				score3 = score2
				score2 = score1
                                score1 = b.score
                        elif b.score > score2:
				score3 = score2
                                score2 = b.score
                        elif b.score > score3:
                                score3 = b.score

		str = "%s\t%i\t%s\t%s\t%i\t%s\t%s\t%i\t%i\t%i\t%i\t%i\t%i\t%i\n" % (read_list[0].chrA,read_list[0].posA,read_list[0].strandA,read_list[0].chrB,read_list[0].posB,read_list[0].strandB,"CTX",len(read_list),mismatch_1,mismatch_2,mismatch_3,score1,score2,score3)
                #print str		
		fout.write(str)
	f1.close()
	fout.close()
		


if __name__=='__main__':
	if len(sys.argv)!=2:
		usage()
		sys.exit(1)
	file1=sys.argv[1]
	call_ctx(file1)
